/*****************************************************************************\
PowerAnt -  :      

    ,   , 
      .    , 
         - , ,
  ,   -    ,
       -  
 -  . 
,       PowerAnt.

	http://www.anthillsolutions.com

() 2005 by Alexey V. Pasthkhov <alexey@anthillsolutions.com>
\******************************************************************************/

/*****************************************************************************\
     ,    
    -    .
\******************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "Begin.h"

#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
#include <winbase.h>
#include <stdlib.h>
#include <time.h>

DCB	pwrAntDCB;
HANDLE	pwrAntHANDLE;
COMMTIMEOUTS pwrAntCommTimeouts;

void ShowError( const char * whereError ){
	LPVOID lpMsgBuf;
	FormatMessage(
	    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
	    NULL,
	    GetLastError(),
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
	    (LPTSTR) &lpMsgBuf,
	    0,
	    NULL
	);
	// Display the string.
	MessageBox( NULL, (const char *)lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

	// Free the buffer.
	LocalFree( lpMsgBuf );
}

BOOL openPwrAntPort( const char * comName ){
        pwrAntHANDLE = CreateFile(
                comName
                ,GENERIC_READ | GENERIC_WRITE // Read-Write access
                ,0 // Cannot be shared
                ,NULL // Security Attributes
                ,OPEN_EXISTING // Open existing file
                ,FILE_ATTRIBUTE_NORMAL || FILE_FLAG_WRITE_THROUGH // | FILE_FLAG_NO_BUFFERING // Auto flush
                ,NULL // Template File
        );
	if( ! pwrAntHANDLE ){
                ShowError("CreateFile");
		return FALSE;
	};
        if( ! GetCommState( pwrAntHANDLE, &pwrAntDCB )){
                ShowError("GetCommState");
		return FALSE;
        };
        if( ! BuildCommDCB( "baud=9600 parity=N data=8 stop=1", &pwrAntDCB ) ){
                ShowError("BuildCommDCB");
		return FALSE;
        };
        if( ! SetCommState( pwrAntHANDLE, &pwrAntDCB )){
                ShowError("SetCommState");
		return FALSE;
        };
        if( ! GetCommTimeouts( pwrAntHANDLE, &pwrAntCommTimeouts ) ){
                ShowError("GetCommTimeouts");
		return FALSE;
        };

        pwrAntCommTimeouts.ReadIntervalTimeout          = 1; // milliseconds
        pwrAntCommTimeouts.ReadTotalTimeoutMultiplier   = 0;  //
        pwrAntCommTimeouts.ReadTotalTimeoutConstant     = 0;  //
        pwrAntCommTimeouts.WriteTotalTimeoutMultiplier  = 0;  //
        pwrAntCommTimeouts.WriteTotalTimeoutConstant    = 0;  //

        if( ! SetCommTimeouts( pwrAntHANDLE, &pwrAntCommTimeouts ) ){
                ShowError("SetCommTimeouts");
		return FALSE;
        };
	return TRUE;
}

BOOL pwrAntCMD( const char * cmd ){
	unsigned char buff[70];
	unsigned long i;
        unsigned long io_i;
	for( i = 0 ; cmd[i] ; i++ ){
		buff[i] = cmd[i];
	};
	buff[i++] = 0x0D;
	buff[i++] = 0x00; //
	if( ! WriteFile(
			pwrAntHANDLE
			,buff
			, i-1 // Do not send Zero at end of command
                        , &io_i
                        , NULL
	)){
		ShowError("WriteFile");
		return FALSE;
	};
	if( ! FlushFileBuffers( pwrAntHANDLE )){
                ShowError("FlushFileBuffers");
                return false;
        };
        // Read the answer from PowerAnt
        bool noError = false;
        do {
                buff[0] = 0;
                if( ! ReadFile(
                        pwrAntHANDLE
                        ,buff
                        , 50 // Full PowerAnt Buffer Length
                        , &io_i
                        , NULL
                )){
                        ShowError("ReadFile");
                        return false;
                };
                buff[io_i] = 0; // Null Termination
                for( unsigned int k = 0 ; k < io_i ; k++ ){
                        if( buff[k] == '+' ){
                                noError = true;
                        };
                        if( buff[k] == 0x0D ){
                                return noError;
                        };
                };
        } while( 1 ); // Dead loop if 0x0D newer come in
	return false;
}

void closePwrAntPort( void ){
        if( ! CloseHandle( pwrAntHANDLE )){
                ShowError("CloseFile");
		return;
	};
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        openPwrAntPort( "COM2" );
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
        closePwrAntPort();
}

void testPass( const char * cmd, TEdit * show, TEdit * showErr ){
        int count = 3600;
        int errors = 0;
        time_t start, end;
        //-------- ?%
        errors = 0;
        start = time( NULL );
        for( int i = 0; i < count ; i++ ){
                if( ! pwrAntCMD( cmd ) ){
                        errors++;
                };
        };
        end = time( NULL );
        show->Text = (end - start);
        showErr->Text = errors;
}

void __fastcall TForm1::Button1Click(TObject *Sender){
        //-------- ?%
        testPass( "?%" , LastChanges, LastChangesErr );
        //-------- ?=
        testPass( "?=" , AllState, AllStateErr );
        //-------- ??
        testPass( "??", GetVersion, GetVersionErr );
        //-------- =A
        testPass( "=A", SwitchA, SwitchAErr );
        //-------- =AbCdEfGh
        testPass( "=AbCdEfGh", SwitchAbcdefgh, SwitchAbcdefghErr );
}


